<?php declare(strict_types=1);

namespace App\Repository;

use App\Entity\{Lenses, PreviouslyOwnedLenses};
use Doctrine\ORM\EntityRepository;

class LensesRepository extends EntityRepository
{
    use AcquireTrait;

    public function deacquire(Lenses $currentRecord): void
    {
        $currentRecord->setFormerlyOwned(TRUE)
            ->setReceived(TRUE);

        $this->moveRecord($currentRecord, new PreviouslyOwnedLenses());
    }

    public function reacquire(PreviouslyOwnedLenses $currentRecord): void
    {
        $currentRecord->setFormerlyOwned(FALSE);

        $this->moveRecord($currentRecord, new Lenses());
    }
}
